﻿using Syncfusion.JavaScript;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Collections;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.Models;
using Syncfusion.EJ.Export;
using System.Reflection;
using Syncfusion.XlsIO;
using System.Reflection.Emit;
using System.Threading;

namespace MVCApp_13_2.Controllers
{
    public class HomeController : Controller
    {
        //List<Orders> order = new List<Orders>(){
        //    new Orders(){ OrderID=1, CustomerID = "C1", EmployeeID=3, Freight = 23.45, OrderDate = new DateTime(2015,08,09), ShipAddress= "NY, USA", ShipCity = "NY", ShipName="Amigo" },
        //    new Orders(){ OrderID=2, CustomerID = "C2", EmployeeID=4, Freight = 33.93, OrderDate = new DateTime(2015,08,09), ShipAddress= "NY, USA", ShipCity = "NY", ShipName="Amigo"},
        //    new Orders(){ OrderID=3, CustomerID = "C3", EmployeeID=5, Freight = 26.35, OrderDate = new DateTime(2015,08,09), ShipAddress= "NY, USA", ShipCity = "NY", ShipName="Amigo"},
        //    new Orders(){ OrderID=4, CustomerID = "C4", EmployeeID=6, Freight = 53.55, OrderDate = new DateTime(2015,08,09), ShipAddress= "NY, USA", ShipCity = "NY", ShipName="Amigo"},
        //    new Orders(){ OrderID=5, CustomerID = "C5", EmployeeID=7, Freight = 23.89, OrderDate = new DateTime(2015,08,09), ShipAddress= "NY, USA", ShipCity = "NY", ShipName="Amigo"}
        //};

        JavaScriptSerializer serializer = new JavaScriptSerializer();

        List<Dictionary<string, object>> order = new List<Dictionary<string, object>>(){
            new Dictionary<string, object>() { { "OrderID", 1}, { "CustomerID", "C1" }, {"EmployeeID", 3}, {"Freight", 23.45} },
                new Dictionary<string, object>() { { "OrderID", 1}, { "CustomerID", "C1" }, {"EmployeeID", 3}, {"Freight", 23.45} },
                new Dictionary<string, object>() { { "OrderID", 1}, { "CustomerID", "C1" }, {"EmployeeID", 3}, {"Freight", 23.45} },
                new Dictionary<string, object>() { { "OrderID", 1}, { "CustomerID", "C1" }, {"EmployeeID", 3}, {"Freight", 23.45} },
                new Dictionary<string, object>() { { "OrderID", 1}, { "CustomerID", "C1" }, {"EmployeeID", 3}, {"Freight", 23.45} }
        };

        public ActionResult Index()
        {
            ViewBag.griddata = order;
            return View();
        }
        //Action to export to excel
        [HttpPost]
        public void ExcelExport(string GridModel)
        {           
            GridProperties gridProperty = ConvertGridObject(GridModel);

            // Get the dynamic table type
            Type test = GetTableType(gridProperty); 

            // Create instance of Array to the dynamic table type
            var inst = Array.CreateInstance(test, 1); 

            string griddata = serializer.Serialize(order);

            // serialize the export data as object array
            var data = serializer.Deserialize(griddata, inst.GetType()) as object[]; 

            ExcelExport exp = new ExcelExport();
          
            exp.Export(gridProperty, data, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");

        }

        [HttpPost]
        public void PdfExport(string GridModel)
        {           
            GridProperties gridProperty = ConvertGridObject(GridModel);

            Type test = GetTableType(gridProperty); // Get the dynamic table type

            var inst = Array.CreateInstance(test, 1); // Create instance of Array to the dynamic table type

            string griddata = serializer.Serialize(order);

            var data = serializer.Deserialize(griddata, inst.GetType()) as object[];
            
            PdfExport exp = new PdfExport();
            
            exp.Export(gridProperty, data, "Export.pdf");
        }

        [HttpPost]
        public void WordExport(string GridModel)
        {
            GridProperties gridProperty = ConvertGridObject(GridModel);
            // Get the dynamic table type
            Type test = GetTableType(gridProperty);

            // Create instance of Array to the dynamic table type
            var inst = Array.CreateInstance(test, 1); 

            string griddata = serializer.Serialize(order);

            var data = serializer.Deserialize(griddata, inst.GetType()) as object[];

            WordExport exp = new WordExport();
           
            exp.Export(gridProperty, data, "Export.docx");
        }

        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

        //Dynamic Type Generator
        public static Type GetTableType(GridProperties gridProperty)
        {
            // Create needed TypeBuilder helpers
            AppDomain myDomain = Thread.GetDomain();
            AssemblyName myAsmName = new AssemblyName("Anonymous");
            AssemblyBuilder myAsmBuilder = myDomain.DefineDynamicAssembly(myAsmName, AssemblyBuilderAccess.Run);

            ModuleBuilder myModBuilder = myAsmBuilder.DefineDynamicModule(myAsmName.Name);
            TypeBuilder myTypeBuilder = myModBuilder.DefineType("TestClass", TypeAttributes.Public);

            foreach (var col in gridProperty.Columns)
            {
                Type PropertyType;
                var PropertyName = col.Field;
                switch (col.Type)
                {
                    case "number": PropertyType = Type.GetType("System.Decimal");
                        break;

                    case "string": PropertyType = Type.GetType("System.String");
                        break;
                    case "boolean": PropertyType = Type.GetType("System.Boolean");
                        break;
                    default: PropertyType = Type.GetType("System.String");
                        break;
                }

                FieldBuilder PropertyFieldBuilder = myTypeBuilder.DefineField(PropertyName.ToLower(), PropertyType, FieldAttributes.Private);

                PropertyBuilder PBuilder = myTypeBuilder.DefineProperty(PropertyName, System.Reflection.PropertyAttributes.HasDefault, PropertyType, null);

                MethodAttributes getSetAttr = MethodAttributes.Public | MethodAttributes.SpecialName | MethodAttributes.HideBySig;

                MethodBuilder getPropertyBuilder = myTypeBuilder.DefineMethod("get" + PropertyName, getSetAttr, PropertyType, Type.EmptyTypes);

                // Constructing IL Code for get and set Methods.
                ILGenerator GetPropGenerator = getPropertyBuilder.GetILGenerator();

                GetPropGenerator.Emit(OpCodes.Ldarg_0);
                GetPropGenerator.Emit(OpCodes.Ldfld, PropertyFieldBuilder);
                GetPropGenerator.Emit(OpCodes.Ret);

                MethodBuilder setPropertyBuulder = myTypeBuilder.DefineMethod("set_" + PropertyName, getSetAttr, null, new Type[] { PropertyType });

                ILGenerator SetPropGenerator = setPropertyBuulder.GetILGenerator();

                SetPropGenerator.Emit(OpCodes.Ldarg_0);
                SetPropGenerator.Emit(OpCodes.Ldarg_1);
                SetPropGenerator.Emit(OpCodes.Stfld, PropertyFieldBuilder);
                SetPropGenerator.Emit(OpCodes.Ret);

                PBuilder.SetGetMethod(getPropertyBuilder);

                PBuilder.SetSetMethod(setPropertyBuulder);
            }

            ConstructorInfo objCtor = typeof(object).GetConstructor(new Type[-1 + 1]);
            ConstructorBuilder pointCtor = myTypeBuilder.DefineConstructor(MethodAttributes.Public, CallingConventions.Standard, Type.EmptyTypes);

            ILGenerator ctorIL = pointCtor.GetILGenerator();

            // Constructing IL Code for the Type Constructor.
            ctorIL.Emit(OpCodes.Ldarg_0);
            ctorIL.Emit(OpCodes.Call, objCtor);
            ctorIL.Emit(OpCodes.Ret);

            return myTypeBuilder.CreateType();
        }
    }

    public class Orders {
        public int OrderID { get; set; }
        public string CustomerID { get; set; }
        public int EmployeeID { get; set; }
        public double Freight { get; set; }        
        public DateTime? OrderDate
        {
            get;
            set;
        }
        public string ShipCity { get; set; }
        public string ShipName { get; set; }
        public string ShipAddress { get; set; }
    }


}